/* pinnipede.cs : this file is part of coincoin.net
 * (c) 2002, kadreg
 */
namespace org.kadreg.coincoin {
  using System.Windows.Forms;
  using System.Drawing;
  using System.Xml;



  public class PinnipedeBox : RichTextBox, IPinnipede{
    // Declarations de Delegations
    public delegate void userHorlogeClicked (string horloge);
    public delegate void urlClicked (string url);
    public delegate void horlogeClicked (string url);
    public delegate void wordClicked (string word);
    public delegate void loginClicked (string login);

    public delegate void supplement (string str);


    // Evenements
    public userHorlogeClicked userHorlogeClickedEvent;
    public urlClicked urlClickedEvent;
    public horlogeClicked horlogeClickedEvent;
    public wordClicked wordClickedEvent;
    public loginClicked loginClickedEvent;
    public supplement supplementEvent;
    

    // fonte courante et font par defaut;
    private Font defaultFont;

    // les donnees interne du canard
    private PinnipedeData datas;

    //L'Id du dernier post affiche
    int lastPost = 0;

    // Le mutex pour les parties sensibles
    // J'ai rien compris au mutex je fait le porc
    //static System.Threading.Mutex MyMutex;
    bool updating;


    public PinnipedeBox () {
      this.Multiline = true;
      this.WordWrap = true;
      this.Text = "";
      this.ReadOnly = true;
      datas = new PinnipedeData ();
      defaultFont = SelectionFont;

      /* un ptiti mutex */
      // MyMutex = new System.Threading.Mutex (true, "MyMutex");
      // J'ai rien compris au mutex je fait le porc
    }


    private bool takeMutex () {
      if (updating) {
	return false;
      } else {
	updating = true;
	return true;
      }
    }

    private void releaseMutex (){
      updating = false;
    }

    public void cleanup () {
/*       Text = ""; */
/*       datas.Clear ();       */
    }

    public void addPost (int id,
			 string login, 
			 string timestamp, 
			 string info, 
			 string message) {
      try {
	datas.addPost (id, login, info, message, timestamp);
      } catch (System.Exception){};
    }
    
    ///<summary> Allez voir en dessous si j'y suis, ce con de langage ne 
    /// supporte pas les attributs avec des valeurs par defaut. Et 
    /// en plus, il le dit a la compilation : 
    /// PinipedeBox.cs(90,70): error CS0241: Default parameter specifiers are not
    ///    permitted
    ///</summary>
    public void AppendHtmlText (string msg, CoinCoinPost post) {
      AppendHtmlText (msg, post, 0);
    }

    /// <summary> Rajoute
    /// Rajoute le text "msg" dans le pinnipede, provenant du post "post"
    /// En plus, cette fonction en profite pour calculer les URL pour les 
    /// enregistrer dans post. Oui, je sais, c'est gruik, mais a marche.
    /// finalement, je rajoute en plus la creation du champs 
    /// previewedMessage dans le post. C'est pour le onMouseOver
    /// </summary>
    public void AppendHtmlText (string msg, CoinCoinPost post, int indexBegin) {
      /* msg contient un text encod en HTML */
      int tagPosition;
      int endTagPosition;
      int spacePosition;
      string tagValue;

      string partToWrite;
      // recherche du premier tag
      tagPosition = msg.IndexOf ("<");
      if (tagPosition == -1) {
	/* pas de tag dans msg, on affiche tout */
	if (msg.Length != 0) {
	  //System.Console.WriteLine ("Affichage chaine : " + msg);
	  msg = System.Web.HttpUtility.HtmlDecode (msg);
	  post.appendUnformatedText (msg);
	  AppendText (msg);
	}
      } else {
	/* on affiche jusqu'au tag, on change de police, 
	 on garde ce qui reste  afficher, et on y go ! */
	//System.Console.WriteLine ("chaine a couper : " + msg + " tagPosition=" + tagPosition);
	/* il y a un cas tordu : la chaine vide, on n'affiche pas de chaines vides  */
	if (tagPosition != 0) {
	  partToWrite = msg.Substring (0, tagPosition);
	  partToWrite = System.Web.HttpUtility.HtmlDecode (partToWrite);
	  //System.Console.WriteLine ("Affichage chaine (2) : " + partToWrite);
	  AppendText (partToWrite);
	  post.appendUnformatedText (partToWrite);
	}

	/* ou est la fin du tag */
	endTagPosition = msg.IndexOf (">", tagPosition);
	//System.Console.WriteLine ("debut/fin : " + tagPosition + "/"+ endTagPosition);
	tagValue = msg.Substring (tagPosition + 1, endTagPosition - tagPosition - 1);
	/* j'ai trouve un tag !!! */

	// System.Console.WriteLine ("Tag trouve : " + tagValue);
	/* on epure la valeur de tagValue pour ne garder que le tag sans parametres */
	spacePosition = tagValue.IndexOf (" ", 0);
	if (spacePosition != -1) {
	  /* *frot* *frot* *frot* */
	  string tagComplete = tagValue;
	  tagValue = tagValue.Substring (0, spacePosition);
	  if (tagValue == "a") {
	    /* il y a une [URL] a recuperer */
	    int indexDebUrl = tagComplete.IndexOf ("\"", 0) + 1;
	    int indexFinUrl = tagComplete.IndexOf ("\"", indexDebUrl) - 1;
	    string url = tagComplete.Substring (indexDebUrl, indexFinUrl - indexDebUrl + 1);
	    int urlIndex = indexBegin + tagPosition;
	    post.createUrl (urlIndex, url);
	    //System.Console.WriteLine ("url found : {0} index {1}", url, urlIndex);
	  } 
	}

	if (tagValue == "/a") {
	  /* commit de l'URL courante */
	  post.commitUrl (indexBegin + tagPosition);
	}

	/* changement de police */
       	switch(tagValue) {
	case "i": SelectionFont = new Font (SelectionFont, FontStyle.Italic); break;
	case "b": SelectionFont = new Font (SelectionFont, FontStyle.Bold);break;
	case "u": SelectionFont = new Font (SelectionFont, FontStyle.Underline);break;
	case "s": SelectionFont = new Font (SelectionFont, FontStyle.Strikeout);break;
	case "a": SelectionColor = Color.DarkBlue; break;
        case "/i":
	case "/b":
	case "/u":
	case "/s":
	case "/a":
	  SelectionFont = new Font (SelectionFont, FontStyle.Regular);
	  SelectionColor = Color.Black;
	  break;
	  
	}

	/* on garde que la fin et on recurse */
	if (endTagPosition < (msg.Length + 1)) {
	  AppendHtmlText (msg.Substring (endTagPosition + 1), post, 
			  indexBegin + tagPosition);
	}
      }

    }

    public void updateDisplay () {      
      SuspendLayout();
      takeMutex ();
      foreach (CoinCoinPost post in datas.GetValueList ()) {
	if (lastPost < post.Id) {
	  SelectionFont = defaultFont;
	  post.writeInPinnipede (this);
	  lastPost = post.Id;      
	}
      }
      releaseMutex ();
      ResumeLayout();
    }

    protected CoinCoinPost getPostFromCharIndex (int index) {
      /* on retourne le premier post ayant un index superieur 
	 a l'index recherche en parcourant datas. Les optimisations, 
	 on verra plus tard */
      CoinCoinPost previous = null;
      foreach (CoinCoinPost post in datas.GetValueList ()) {
	if (post.Index >= index) return previous;
	previous = post;
      }      
      return previous;
    }

    protected CoinCoinPost findPostFromHorloge (string horloge) {
      foreach (CoinCoinPost post in datas.GetValueList ()) {
	if (post.Timestamp == horloge) {
	  return post;
	}
      }
      return null;
    }

    protected override void OnMouseDown (MouseEventArgs e) {
      if (takeMutex ()) {
	try {
	  int index = this.GetCharIndexFromPosition (new Point (e.X, e.Y));
	  int line = this.GetLineFromCharIndex (index);
	  CoinCoinPost post = getPostFromCharIndex (index);
	  // System.Console.WriteLine ("Evenement move X={0} Y={1} index={2} line={3}", 
	  //			    e.X, e.Y, index, line);
	  // System.Console.WriteLine ("Message={0}", post.Message);
	  InterrestingThing IT = post.findInterrestingThingInPost (index - post.Index);
	  if (IT.type == InterrestingThingType.LeftHorloge) {
	    /* on leve l'evenement userHorlogeClicked */
	    if (userHorlogeClickedEvent != null) userHorlogeClickedEvent (IT.value);
	  } else if (IT.type == InterrestingThingType.Login) {
	    if (loginClickedEvent != null) loginClickedEvent (IT.value);
	  } else if (IT.type == InterrestingThingType.URL) {
	    if (urlClickedEvent != null) loginClickedEvent (IT.value);
	  } else if (IT.type == InterrestingThingType.Horloge) {
	    if (horlogeClickedEvent != null) loginClickedEvent (IT.value);
	  } else if (IT.type == InterrestingThingType.Word) {
	    if (wordClickedEvent != null) loginClickedEvent (IT.value);
	  }

	} catch (System.Exception) {
	}
	releaseMutex ();
      }    
    }


    protected override void OnMouseMove (MouseEventArgs e) {
      /* recuperation du chartactere sur lequel on est */
      if (takeMutex ()) {
	try {
	  int index = this.GetCharIndexFromPosition (new Point (e.X, e.Y));
	  int line = this.GetLineFromCharIndex (index);
	  CoinCoinPost post = getPostFromCharIndex (index);
	  InterrestingThing IT = post.findInterrestingThingInPost (index - post.Index);
	  if (supplementEvent != null) {
	    if (IT.type == InterrestingThingType.LeftHorloge) {
	      supplementEvent (post.Info);
	    } else if (IT.type == InterrestingThingType.Horloge) {
	      string mess = findPostFromHorloge (IT.value).UnformatedMessage;	      
	      supplementEvent (System.Web.HttpUtility.HtmlDecode (mess));
	    } else if (IT.type != InterrestingThingType.Nothing) {
	      supplementEvent (IT.value);
	    } else {
	      supplementEvent ("");
	    }
	  }
	  // System.Console.WriteLine ("Evenement move X={0} Y={1} index={2} line={3}", 
	  //			    e.X, e.Y, index, line);
	  // System.Console.WriteLine ("Message={0}", post.Message);
	} catch (System.Exception) {
	}
	releaseMutex ();
      }
    }
  }
}
