/* coincoinform.cs : this file is part of coincoin.net
 * (c) 2002, kadreg
 */
namespace org.kadreg.coincoin {

  using System.Windows.Forms;
  using System.Threading;
  using System.Drawing;
  using System.Net;
  using System.Web;
  using System.IO;
  using System.Text;
  using System.Xml;

  public class CoinCoinForm : Form {
    private string title;
    // objets IHM
    private TextBox txtMessage;
    private TextBox txtSupplement;
    private PinnipedeBox pinnipede;
    private Button boutonRetrieve;

    // les pitits boutons 
    System.Collections.ArrayList buttonsList 
      = new System.Collections.ArrayList ();

    // objets threads recuperation 
    private Thread retrieveThread;
    private Thread postThread;

    public CoinCoinForm (string version) {
      title = "coincoin.net " + version;
      this.Text = title;
      this.Opacity = 0.95;
      createIHMObjects ();
      createMenus ();
      DoLayout ();

      // On se connecte sur les evenements du pinnipede
      pinnipede.userHorlogeClickedEvent += 
	new PinnipedeBox.userHorlogeClicked(leftHorlogeClicked);
      pinnipede.horlogeClickedEvent += 
	new PinnipedeBox.horlogeClicked(horlogeClicked);
      pinnipede.loginClickedEvent += 
	new PinnipedeBox.loginClicked(loginClicked);
      pinnipede.supplementEvent += 
	new PinnipedeBox.supplement(displayMoreInformations);
      txtMessage.KeyPress += new KeyPressEventHandler (messageKeyPressed);

/*       this.BackgroundImage = new Bitmap ("salma.jpg"); */
/*       pinnipede.BackColor = Color.Transparent; */
    }


    /// creation des menus de la form principale.
    private void createMenus () {
      // le main menu
      MainMenu mainMenu = new MainMenu ();

      // les items de premier niveau
      MenuItem MIActions = new MenuItem (); 
      MenuItem MIConfiguration = new MenuItem (); 
      MenuItem MIHelp = new MenuItem (); 
      MIActions.Text = "&Actions";
      MIConfiguration.Text = "&Configuration";
      MIHelp.Text = "&Aide";
      mainMenu.MenuItems.Add (MIActions);
      mainMenu.MenuItems.Add (MIConfiguration);
      mainMenu.MenuItems.Add (MIHelp);

      /* contenu du menu help */
      MenuItem MI2About = new MenuItem ();
      MI2About.Text = "A propos de...";
      MIHelp.MenuItems.Add (MI2About);
      MI2About.Click += new System.EventHandler (this.displayAboutBox);

      
      /* on l'ajoute  la From */
      this.Menu = mainMenu;
    }

    private void leftHorlogeClicked (string h) {
      txtMessage.AppendText (h + " ");
      txtMessage.Focus ();
    }

    private void horlogeClicked (string h) {
      System.Console.WriteLine ("horloge clicked : " + h);
    }

    private void loginClicked (string l) {
      txtMessage.AppendText (l + "< ");
    }

    private void displayMoreInformations (string infos) {
      txtSupplement.Text = infos;
    }

    private void createIHMObjects () {
      // creations 
      Button button;

      txtMessage = new TextBox ();
      pinnipede = new PinnipedeBox ();
      boutonRetrieve = new Button ();
      txtSupplement = new TextBox ();

      txtMessage.Multiline = false;
      txtMessage.Name = "txtMessage";
      txtMessage.TabIndex = 2;
      txtMessage.Text = "";

      txtSupplement.Multiline = true;
      txtSupplement.Name = "txtSupplement";
      txtSupplement.TabIndex = 10;
      txtSupplement.Text = "";
      txtSupplement.WordWrap = true;
      txtSupplement.ReadOnly = true;


      pinnipede.Name = "pinnipede"; 
      pinnipede.TabIndex = 1;

      boutonRetrieve.TabIndex = 3;
      boutonRetrieve.Text = "&R";
      boutonRetrieve.Click += new System.EventHandler (this.getNewMessages);

      // Options de la boite
      this.ClientSize = new Size (330, 400);

      // creations des pitits boutons
      // bold
      string [] buttonsTags = {"b", "i", "u", "s", "tt"};
      foreach (string txt in buttonsTags) {
	button = new Button (); 
	button.Text = txt;
	this.Controls.Add (button);
	buttonsList.Add (button);
	button.Click += new System.EventHandler (this.addTag);
      }

      // Ajout dans la form
      this.Controls.Add (txtMessage);
      this.Controls.Add (pinnipede);
      this.Controls.Add (boutonRetrieve);
      this.Controls.Add (txtSupplement);

      this.Layout += new LayoutEventHandler (this.EventLayout);

    }

    private void DoLayout () {

      int width = this.ClientSize.Width;
      int height = this.ClientSize.Height;

      // Tailles et options
      txtMessage.Location = new Point (10, height - 75);
      txtMessage.Size = new Size (width - 70, 24);

      txtSupplement.Location = new Point (10,10);
      txtSupplement.Size = new Size (width - 20, 48);

      pinnipede.Location = new Point (10,60);
      pinnipede.Size = new Size (width - 20, height - 150);

      boutonRetrieve.Location  = new Point (width - 50, height - 75);
      boutonRetrieve.Size = new Size (40, 20);

      /* on fait les petits boutons */
      int x = 10;
      foreach (Button b in buttonsList) {
	b.Location = new Point (x, height - 50);
	b.Size = new Size (35, 20);
	x += 35;
      }

    }

    // callback event resize & layout
    private void EventLayout (object sender, LayoutEventArgs e) {
      DoLayout ();
    }

    private void messageKeyPressed (object sender, KeyPressEventArgs e){
      /* Si c'est entree, on valide */
      if (e.KeyChar == (char)13) {
	if ((postThread != null) && postThread.IsAlive) {
	  postThread.Abort ();
	}
	
	postThread = new Thread 
	  (new ThreadStart (postMessageData));
	postThread.Start ();	
      }
    }

    /// <summary> 
    /// </summary>
    private void addTag (object sender, System.EventArgs e) {
      try {
	Button b = (Button)sender;
	addHtmlTagsInTxtMessage (b.Text);
      } catch (System.Exception) {	
	// poudou poudou
	MessageBox.Show ("C'est quoi ce bouton a la con ?", "Paf ");
      }
    }


    /// Callback bouton post messages
    private void postMessage (object sender, System.EventArgs e) {
      if ((postThread != null) && postThread.IsAlive) {
	postThread.Abort ();
      }

      postThread = new Thread 
	(new ThreadStart (postMessageData));
      postThread.Start ();
    }

    /// Callback bouton get new messages
    private void getNewMessages (object sender, System.EventArgs e) {
      if ((retrieveThread != null) && retrieveThread.IsAlive) {
	retrieveThread.Abort ();
      }

      retrieveThread = new Thread 
	(new ThreadStart (retrieveMessages));
      retrieveThread.Start ();
    }

    private void postMessageData () {
      string postAddr = CoinCoinConfig.PostAddr;
      string request;
      
      string messageToPost = txtMessage.Text;
      txtMessage.Enabled = false;
      System.Console.WriteLine ("Message to post : {0}", messageToPost);
      WebClient myWebClient = new WebClient ();

      myWebClient.Headers.Add ("User-Agent", title);
      /* le cookie d'authentification */
      myWebClient.Headers.Add ("Cookie", "session_id=" + CoinCoinConfig.SessionId);
      myWebClient.Headers.Add ("Content-Type", "application/x-www-form-urlencoded");

      /* encodage de request selon la norme urlencoding. " "-> %20 */
      string encodedMessage = HttpUtility.UrlEncode(messageToPost);      

      /* koi goret ?, c'est pas ma  faute si URLEncode ne sait
	 pas ce qu'est un accent, alors je rpare ses conneries
	 UrlEncode, tu pues la merde ! */    
      encodedMessage = encodedMessage.Replace ("%c3", ""); // caractere de merde
      encodedMessage = encodedMessage.Replace ("%a0", "%E0"); // 
      encodedMessage = encodedMessage.Replace ("%a2", "%E2"); // 
      encodedMessage = encodedMessage.Replace ("%a4", "%E4"); // 

      encodedMessage = encodedMessage.Replace ("%a9", "%E9"); // 
      encodedMessage = encodedMessage.Replace ("%a8", "%E8"); // 
      encodedMessage = encodedMessage.Replace ("%aa", "%EA"); // 
      encodedMessage = encodedMessage.Replace ("%ab", "%EB"); // 

      encodedMessage = encodedMessage.Replace ("%ae", "%EE"); // 
      encodedMessage = encodedMessage.Replace ("%af", "%EF"); // 

      encodedMessage = encodedMessage.Replace ("%b4", "%F4"); // 
      encodedMessage = encodedMessage.Replace ("%b6", "%F6"); // 

      encodedMessage = encodedMessage.Replace ("%b9", "%F9"); // 
      encodedMessage = encodedMessage.Replace ("%bb", "%FB"); // 
      encodedMessage = encodedMessage.Replace ("%bc", "%FC"); // 

      encodedMessage = encodedMessage.Replace ("%b1", "%F1"); // 
      encodedMessage = encodedMessage.Replace ("%a7", "%E7"); // 
      

      request = "message=" + encodedMessage + "&board_section=1&section=1";

      System.Console.WriteLine ("request: " + request);
      byte[] byteArray = Encoding.ASCII.GetBytes (request);

      System.Console.WriteLine ("Encoded request : {0}", 
 				System.Text.Encoding.ASCII.GetString (byteArray)); 

      try {
	byte[] responseArray = myWebClient.UploadData (postAddr, "POST", byteArray );
	/* verifions responseArray pour savoir si a s'est bien pass */
	if (responseArray.Length < 1024) {
	  /* Le serveur a retourne un message sybillin. */
	  throw new System.Exception (System.Text.Encoding.ASCII.GetString (responseArray));
	}
	
	txtMessage.Text = "";
      } catch (System.Exception e) {
	MessageBox.Show (e.Message, "HTTP Error");
      }
      /* on met a jour avec les nouveaux messages, et pour voir
	 apparaitre le message que l'on vient de poster */
      txtMessage.Enabled = true;
      retrieveMessages ();
    }

    private void retrieveMessages () {
      boutonRetrieve.Enabled = false;
      System.Console.WriteLine ("StartMessageRetrieving");
      WebRequest requete = WebRequest.Create (CoinCoinConfig.BackendURL);
      WebResponse reponse = requete.GetResponse ();
      
      Stream mStream = reponse.GetResponseStream ();
      StreamReader mReader = new StreamReader (mStream);
      string s = mReader.ReadToEnd ();
      System.Console.WriteLine ("EndMessageRetrieving");      
      try {
	UpdatePinnipedeWithXmlString (s);
      } catch (XmlException e) {
	MessageBox.Show ("Explosion de slip : " + e.Message, "BOOM");
      }
      boutonRetrieve.Enabled = true;
    }

    /// Un bon gros parseur tout a la main. Houplaboom suxor !
    private void UpdatePinnipedeWithXmlString (string xml) {
      int id;
      string date;
      string message;
      string info;
      string login;

      int postIndex = xml.IndexOf ("<post", 0);
      while (postIndex != -1) {
	/* on est sur un post */
	/* recuperation de l'attribut date */
	int dateDebut = xml.IndexOf ("=\"", postIndex ) + 2;
	int dateFin = xml.IndexOf ("\"", dateDebut ) -1;
	date = xml.Substring (dateDebut, dateFin - dateDebut + 1);

	/* attribut Id */ 
	int idDebut = xml.IndexOf ("=\"", dateFin) + 2;
	int idFin = xml.IndexOf ("\"", idDebut);
	string sid = xml.Substring (idDebut, idFin - idDebut);
	id = System.Convert.ToInt32 (sid);

	/* champs info */
	int infoDebut = xml.IndexOf ("<info>", idFin) + 6;
	int infoFin = xml.IndexOf ("</info>", infoDebut);
	info = xml.Substring (infoDebut, infoFin - infoDebut);

	/* champs message */
	int messageDebut = xml.IndexOf ("<message>", infoFin) + 9;
	int messageFin = xml.IndexOf ("</message>", messageDebut);
	message = xml.Substring (messageDebut, messageFin - messageDebut);

	/* champs login */
	int loginDebut = xml.IndexOf ("<login>", idFin) + 7;
	int loginFin = xml.IndexOf ("</login>", idFin);
	login = xml.Substring (loginDebut, loginFin - loginDebut);

	/* ajout de le post dans le pinnipede */
	pinnipede.addPost (id, login, date, info, message);

	/* au suivant ! */
	postIndex = xml.IndexOf ("<post", loginFin);
      }
      pinnipede.updateDisplay ();

    }

    public void addHtmlTagsInTxtMessage (string tag) {
	txtMessage.SelectedText ="<" + tag +">" +
				 txtMessage.SelectedText + 
				 "</" + tag +">";
    }

    /// callback pour l'affichage de la boite about
    private void displayAboutBox (object sender, System.EventArgs e) {
      System.Console.WriteLine ("Calling aboutBox");

      CoinCoinAboutForm aboutBox = new CoinCoinAboutForm (title);
      aboutBox.ShowDialog (this);
    }

  }
}

